'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Anchor = require('./Anchor');

var _Anchor2 = _interopRequireDefault(_Anchor);

var _elementType = require('./prop-types/elementType');

var _elementType2 = _interopRequireDefault(_elementType);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var BreadcrumbItem = _react2.default.createClass({
    displayName: 'BreadcrumbItem',

    propTypes: {
        active: _react2.default.PropTypes.bool,
        componentClass: _elementType2.default
    },

    getDefaultProps: function getDefaultProps() {
        return {
            active: false
        };
    },
    renderItem: function renderItem() {
        var _props = this.props,
            componentClass = _props.componentClass,
            children = _props.children,
            active = _props.active,
            props = _objectWithoutProperties(_props, ['componentClass', 'children', 'active']);

        var Component = componentClass || _Anchor2.default;

        if (active) {
            return _react2.default.createElement(
                'span',
                props,
                children
            );
        }

        return _react2.default.createElement(
            Component,
            props,
            children
        );
    },
    render: function render() {
        var _props2 = this.props,
            active = _props2.active,
            className = _props2.className;


        return _react2.default.createElement(
            'li',
            { className: (0, _classnames2.default)(className, { active: active }) },
            this.renderItem()
        );
    }
});

exports.default = BreadcrumbItem;