'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _createChainedFunction = require('./utils/createChainedFunction');

var _createChainedFunction2 = _interopRequireDefault(_createChainedFunction);

var _FormControlMixin = require('./mixins/FormControlMixin.js');

var _FormControlMixin2 = _interopRequireDefault(_FormControlMixin);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Checkbox = _react2.default.createClass({
    displayName: 'Checkbox',

    mixins: [_FormControlMixin2.default],
    propTypes: {
        id: _react2.default.PropTypes.string,
        name: _react2.default.PropTypes.string,
        inline: _react2.default.PropTypes.bool,
        title: _react2.default.PropTypes.string,
        disabled: _react2.default.PropTypes.bool,
        checked: _react2.default.PropTypes.bool,
        onChange: _react2.default.PropTypes.func,
        value: _react2.default.PropTypes.any
    },
    contextTypes: {
        formGroup: _react2.default.PropTypes.object
    },
    getInitialState: function getInitialState() {
        return {
            checked: this.props.checked
        };
    },
    getFormGroup: function getFormGroup() {
        return this.context.formGroup || {};
    },
    handleChange: function handleChange(event) {
        if (this.props.disabled) {
            return;
        }

        var checked = !this.state.checked;

        var value = checked ? this.props.value : '';
        var onChange = this.props.onChange;

        var _getFormGroup = this.getFormGroup(),
            onFormGroupChange = _getFormGroup.onChange;

        this.setState({
            checked: checked
        }, function () {
            onChange && onChange(value);
            onFormGroupChange && onFormGroupChange(value);
        });
    },
    componentWillReceiveProps: function componentWillReceiveProps(nextProps) {
        if (nextProps.checked !== this.props.checked) {
            this.setState({
                checked: nextProps.checked
            });
        }
    },
    render: function render() {
        var _props = this.props,
            inline = _props.inline,
            title = _props.title,
            name = _props.name,
            disabled = _props.disabled,
            className = _props.className,
            children = _props.children,
            onChange = _props.onChange,
            value = _props.value,
            props = _objectWithoutProperties(_props, ['inline', 'title', 'name', 'disabled', 'className', 'children', 'onChange', 'value']);

        var checked = this.state.checked;

        var classes = (0, _classnames2.default)({
            'checkbox-inline': inline
        }, className);

        var checkboxClasses = (0, _classnames2.default)({
            'checker': true,
            'disabled': disabled
        });

        var input = _react2.default.createElement(
            'span',
            { className: (0, _classnames2.default)({ 'checked': checked }) },
            _react2.default.createElement('input', {
                type: 'checkbox',
                name: name,
                checked: checked !== undefined ? checked : value,
                value: value,
                disabled: disabled,
                onChange: this.handleChange,
                defaultChecked: this.state.checked
            })
        );

        return _react2.default.createElement(
            'label',
            _extends({ className: classes }, props),
            _react2.default.createElement(
                'div',
                { className: checkboxClasses, role: 'checkbox' },
                input
            ),
            title || children
        );
    }
});

exports.default = Checkbox;