'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Checkbox = require('./Checkbox');

var _Checkbox2 = _interopRequireDefault(_Checkbox);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var CheckboxGroup = _react2.default.createClass({
    displayName: 'CheckboxGroup',

    propTypes: {
        name: _react2.default.PropTypes.string,
        inline: _react2.default.PropTypes.bool,
        value: _react2.default.PropTypes.array,
        defaultValue: _react2.default.PropTypes.array,
        onChange: _react2.default.PropTypes.func
    },
    contextTypes: {
        formGroup: _react2.default.PropTypes.object
    },
    getFormGroup: function getFormGroup() {
        return this.context.formGroup || {};
    },
    handleChange: function handleChange(checked) {

        var refs = this.refs;
        var value = [];
        var onChange = this.props.onChange;

        var _getFormGroup = this.getFormGroup(),
            onFormGroupChange = _getFormGroup.onChange;

        for (var key in refs) {
            if (refs[key].state.checked) {
                value.push(refs[key].props.value);
            }
        }
        onChange && onChange(value);
        onFormGroupChange && onFormGroupChange(value);
    },
    render: function render() {
        var _this = this;

        var _props = this.props,
            className = _props.className,
            inline = _props.inline,
            name = _props.name,
            value = _props.value,
            defaultValue = _props.defaultValue,
            children = _props.children;


        var nextValue = Object.assign([], value, defaultValue);
        var clesses = (0, _classnames2.default)({
            'checkbox-list': true
        }, className);

        var items = _react2.default.Children.map(children, function (child, index) {
            return _react2.default.cloneElement(child, {
                key: index,
                ref: 'checkbox_' + index,
                inline: inline,
                checked: nextValue.some(function (i) {
                    return i === child.props.value;
                }),
                onChange: _this.handleChange,
                name: name
            }, child.props.children);
        });

        return _react2.default.createElement(
            'div',
            {
                className: clesses,
                role: 'checkbox-list'
            },
            items
        );
    }
});

exports.default = CheckboxGroup;