'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var HelpBlock = _react2.default.createClass({
    displayName: 'HelpBlock',

    propTypes: {
        htmlFor: _react2.default.PropTypes.string
    },
    contextTypes: {
        formGroup: _react2.default.PropTypes.object
    },
    render: function render() {
        var _context$formGroup = this.context.formGroup,
            controlId = _context$formGroup.controlId,
            isValid = _context$formGroup.isValid,
            errorMessage = _context$formGroup.errorMessage;
        var _props = this.props,
            className = _props.className,
            _props$htmlFor = _props.htmlFor,
            htmlFor = _props$htmlFor === undefined ? controlId : _props$htmlFor,
            children = _props.children;


        var valid = isValid === undefined ? true : isValid;

        var classes = (0, _classnames2.default)({
            'help-block': true,
            'error': !valid
        }, className);

        return _react2.default.createElement(
            'span',
            {
                htmlFor: htmlFor,
                className: classes
            },
            !valid && errorMessage || children
        );
    }
});

exports.default = HelpBlock;