'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _ClassNameMixin = require('./mixins/ClassNameMixin');

var _ClassNameMixin2 = _interopRequireDefault(_ClassNameMixin);

var _elementType = require('./prop-types/elementType');

var _elementType2 = _interopRequireDefault(_elementType);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var IconFont = _react2.default.createClass({
    displayName: 'IconFont',

    mixins: [_ClassNameMixin2.default],
    propTypes: {
        classPrefix: _react.PropTypes.string,
        componentClass: _elementType2.default,
        icon: _react.PropTypes.string.isRequired,
        size: _react.PropTypes.oneOf(['lg', '2x', '3x', '4x', '5x']),
        flip: _react.PropTypes.oneOf(['horizontal', 'vertical']),
        stack: _react.PropTypes.oneOf(['1x', '2x']),
        rotate: _react.PropTypes.number,
        fixedWidth: _react.PropTypes.bool,
        spin: _react.PropTypes.bool,
        pulse: _react.PropTypes.bool
    },
    getDefaultProps: function getDefaultProps() {
        return {
            componentClass: 'i',
            classPrefix: 'icon'
        };
    },
    render: function render() {
        var _classNames;

        var _props = this.props,
            Component = _props.componentClass,
            className = _props.className,
            classPrefix = _props.classPrefix,
            icon = _props.icon,
            size = _props.size,
            fixedWidth = _props.fixedWidth,
            spin = _props.spin,
            pulse = _props.pulse,
            rotate = _props.rotate,
            flip = _props.flip,
            stack = _props.stack,
            props = _objectWithoutProperties(_props, ['componentClass', 'className', 'classPrefix', 'icon', 'size', 'fixedWidth', 'spin', 'pulse', 'rotate', 'flip', 'stack']);

        var classes = (0, _classnames2.default)(classPrefix, this.prefix(icon), className, (_classNames = {}, _defineProperty(_classNames, classPrefix + '-' + size, size), _defineProperty(_classNames, classPrefix + '-fw', fixedWidth), _defineProperty(_classNames, classPrefix + '-spin', spin), _defineProperty(_classNames, classPrefix + '-pulse', pulse), _defineProperty(_classNames, classPrefix + '-flip-' + flip, flip), _defineProperty(_classNames, classPrefix + '-rotate-' + rotate, rotate), _defineProperty(_classNames, classPrefix + '-stack-' + stack, stack), _classNames));

        return _react2.default.createElement(Component, _extends({}, props, { className: classes }));
    }
});

exports.default = IconFont;